public class Eingangsfuzzyset
{
     private double[] stellen = null;
     private iFuzzygroesse[] fuzzygroesse = null;
     
     private double[] aktivierung = null;
     
     public Eingangsfuzzyset(double[] stellen)
     {
          if(stellen==null)
          {
              println("ERROR in Konstruktor Eingangsfuzzyset: keine stellen");
              return;
          }    
          if(stellen.length<2)
          {
              println("ERROR in Konstruktor Eingangsfuzzyset: weniger als 2 stellen");
              return;
          }    
          for(int i=0;i<stellen.length-1;i++)
          {
              if(stellen[i+1]<=stellen[i])
              {
                  println("ERROR in Konstruktor Eingangsfuzzyset: stellen nicht streng monoton ansteigend");
                  return;                   
              }
          }
          
          this.stellen = new double[stellen.length];
          for(int i=0;i<stellen.length;i++)
              this.stellen[i] = stellen[i];
              
          fuzzygroesse = new iFuzzygroesse[stellen.length];
          
          fuzzygroesse[0] = new FuzzygroesseLinks(stellen,0);
          for(int i=1;i<stellen.length-1;i++)
              fuzzygroesse[i] = new FuzzygroesseMitte(stellen,i-1);
          fuzzygroesse[stellen.length-1] = new FuzzygroesseRechts(stellen,stellen.length-2);
          
          aktivierung = new double[stellen.length];
     }
     
     public double[] berechneAktivierungen(double signal)
     {
           for(int i=0;i<aktivierung.length;i++)
               aktivierung[i] = fuzzygroesse[i].berechneAktivierung(signal);
           return aktivierung;    
     }
}
