//vergl:
//    http://www.kramann.info/64_Regelungssysteme/18_Fuzzy/03_Uebung9/index.php

//  neg  null pos
//  ----\/\/---- Eingangsfuzzysets  für x und v
//  -0.1 0 0.1
//
//  neg null pos
//  /\/\/\       Ausgangsfuzzyset für F
//-2 -1 0 1 2   (-1 0 und 1 sind jeweils die Maxima der Dreiecke)
//
//  Regeln:    Legende: +==pos -=neg 0=null
//0.  WENN  v- UND x- DANN F+
//1.  WENN  v- UND x0 DANN F+   oder 0?
//2.  WENN  v- UND x+ DANN F0
//3.  WENN  v0 UND x- DANN F0   oder +?
//4.  WENN  v0 UND x0 DANN F0
//5.  WENN  v0 UND x+ DANN F0   oder -?
//6.  WENN  v+ UND x- DANN F0
//7.  WENN  v+ UND x0 DANN F-   oder 0?
//8.  WENN  v+ UND x+ DANN F-
FuzzySystem fuzzyregler = new FuzzySystem(
     new double[][] {
                        {-0.1,0.0,0.1},  //Stellen erstes Eingangsfuzzyset für v
                        {-0.1,0.0,0.1}   //Stellen zweites Eingangsfuzzyset für x
                    },
     new double[]   {-2.0,-1.0,0.0,1.0,2.0},  //Ausgangsfuzzyset (das sind auch nur 3 Fuzzygrößen, Indices 0 1 2)
     new int[][]  {
                      //0.  WENN  v- UND x- DANN F+
                      {0,0,2},
                      //1.  WENN  v- UND x0 DANN F+   oder 0?
                      {0,1,2},
                      //2.  WENN  v- UND x+ DANN F0
                      {0,2,1},
                      //3.  WENN  v0 UND x- DANN F0   oder +?
                      {1,0,1},
                      //4.  WENN  v0 UND x0 DANN F0
                      {1,1,1},
                      //5.  WENN  v0 UND x+ DANN F0   oder -?
                      {1,2,1},
                      //6.  WENN  v+ UND x- DANN F0
                      {2,0,1},
                      //7.  WENN  v+ UND x0 DANN F-   oder 0?
                      {2,1,0},
                      //8.  WENN  v+ UND x+ DANN F-
                      {2,2,0}
                  }
     
     );


public void setup()
{
     double R,T;
     
     FuzzySystem fuzzysystem = new FuzzySystem(
     
     new double[][] {
                        {5.0,10.0,20.0},  //Stellen erstes Eingangsfuzzyset
                        {5.0,20.0}   //Stellen zweites Eingangsfuzzyset
                    },
     new double[]   {-2.5,5.0,20.0,27.5},  //Ausgangsfuzzyset
     new int[][]  {
                         //WENN R kalt UND T warm DANN A warm.      
                         {0,1,1},   //Regel1
                         //WENN R mittel UND T kalt DANN A kalt.
                         {1,0,0}   //Regel2
                    }
     
     );
     
     R=7.0;
     T=12.5;
     println("NEUNEU Stellgroesse A bei R="+R+" T="+T+" A="+fuzzysystem.berechneAusgang(new double[] {R,T}));
     
     R=5.0;
     T=7.0;
     println("NEUNEU Stellgroesse A bei R="+R+" T="+T+" A="+fuzzysystem.berechneAusgang(new double[] {R,T}));

     boolean fuzzy_regler_aktiv = false;
     double FEHLER = berechneAuslenkung(fuzzy_regler_aktiv);
     fuzzy_regler_aktiv = true;
     double FEHLER_FUZZY = berechneAuslenkung(fuzzy_regler_aktiv);
     
     println("Fehler mit F==0 ist:"+FEHLER);
     println("Fehler mit Fuzzyregler ist:"+FEHLER_FUZZY);
}

public void draw()
{
}
