public class FuzzygroesseMitteAusgang extends FuzzygroesseMitte
{
     public FuzzygroesseMitteAusgang(double[] stellen, int index)
     {
         super(stellen,index);
     }
  
     //Trapez-Hilfsfunktionen für Ausgangsfuzzyset

     //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     //ACHTUNG: x3 beim Dreieck ist x4 beim Trapez!
     //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     
//       /|
//      / |
//     /  |
//    x1  x2
//
private double schwerpunktDreieckLinks(double x1, double x2)
{
      return x1 + (2.0/3.0)*(x2-x1);
}

//        |\
//        | \
//        |  \
//        x1  x2
//
private double schwerpunktDreieckRechts(double x1, double x2)
{
      return x1 + (1.0/3.0)*(x2-x1);
}

private double flaecheDreieck(double x1, double x2, double h)
{
      return h*(x2-x1)*0.5;
}


//
//        _______
//       /|      |\
//      / |      h \
//     /  |      |  \
//    x1  x2     x3 x4
//
private double flaecheTrapez(double x1, double x2, double x3, double x4, double h)
{
    return (x3-x2)*h + flaecheDreieck(x1,x2,h)+flaecheDreieck(x3,x4,h);      
}
private double flaecheTrapez(double[] x)
{
    return flaecheTrapez(x[0],x[1],x[2],x[3],x[4]);    
}

private double schwerpunktTrapez(double x1, double x2, double x3, double x4, double h)
{
    double A1 = flaecheDreieck(x1,x2,h);
    double A2 = (x3-x2)*h;
    double A3 = flaecheDreieck(x3,x4,h);
    
    double sx1 = schwerpunktDreieckLinks(x1,x2);
    double sx2 = x2 + (x3-x2)*0.5;
    double sx3 = schwerpunktDreieckRechts(x3,x4);
    
    return (sx1*A1+sx2*A2+sx3*A3)/(A1+A2+A3);
}

private double schwerpunktTrapez(double[] x)
{
    return schwerpunktTrapez(x[0],x[1],x[2],x[3],x[4]);
}
//           /\
//          /  \
//         /    \
//        _______
//       /|      |\
//      / |      h \
//     /  |      |  \
//    x1  x2 xmax x3 x4
//
//    Input: x1 xmax x4
//   Output: x2 x3
private double[] schnittstellen(double x1,double xmax,double x4, double h)
{
      //gesucht: x2
      // h = (x2-x1)*s Steigung s = 1.0/(xmax-x1)
      // h = (x2-x1)/(xmax-x1)
      // x2 = h*(xmax-x1) + x1;
      double x2 = h*(xmax-x1) + x1;
      
      
      //gesucht: x3
      // 0 = h - (x4-x3)*s2  Steigung s2 = 1.0/(x4-xmax)
      // 0 = h - (x4-x3)/(x4-xmax)
      // h = (x4-x3)/(x4-xmax)
      // x4-x3 = h*(x4-xmax)
      //    x3 = x4 - h*(x4-xmax)
      double x3 = x4 - h*(x4-xmax);

      //println("Trapezknickstellen: x1="+x1+" xmax="+xmax+" x4="+x4+" h="+h+" dann sind x2="+x2+", x3="+x3);

      x2x3[0] = x2;
      x2x3[1] = x3;
      
      return x2x3;
}     
     //ENDE Trapez-Hilfsfunktionen für Ausgangsfuzzyset
     
     public double[] berechneTrapezflaecheUndSchwerpunkt(double hoehe) //hoehe entspricht aktivierung, die sich aus den Regeln ergibt
     {
          //Knickstellen des Trapezes bestimmen:
          double[] x2x3 = schnittstellen(this.x1,this.x2,this.x3,hoehe); 
       
          flaeche_schwerpunkt[0] = flaecheTrapez(this.x1, x2x3[0], x2x3[1], this.x3, hoehe);
          flaeche_schwerpunkt[1] = schwerpunktTrapez(this.x1, x2x3[0], x2x3[1], this.x3, hoehe);
       
          //....
          return flaeche_schwerpunkt; //in dieser Reihenfolge!          
     }
           
}
